class gameCls {
	void loop ();

	public:
		screenCls scrn;
		shipCls s;
		alienCls *aliens;
		unsigned NumOfAliens;

		gameCls ();

		~gameCls () {
			delete [] aliens;
		}

		void moveShip ();
		void moveAlien (const int i);
		void moveBullet (const int i);
		int shipHitAliens ();
		int alienHitShip (const unsigned i);
		void killedShip ();
		void printStatus ();
		int bulletHitAlien (const unsigned j);
		int alienHitBullet (const unsigned i);
		void endGame (int i);
		int allDead ();
		void NextStage ();
};

gameCls::gameCls () {
	unsigned i;

	randomize ();

	scrn.getRndCoords (s.x, s.y);
	s.show ();
	printStatus ();

	aliens = new alienCls[NumOfAliens = 5];
	for (i = 0; i < NumOfAliens; i++) {
		scrn.getRndCoords (aliens[i].x, aliens[i].y);
		aliens[i].show ();
	}

	loop ();
}

void gameCls::moveShip () {
	if (!scrn.onWall (s.x + s.addxN, s.y + s.addyN)) {
		s.addx = s.addxN; s.addy = s.addyN;
	}

	s.show (0);
	if (!scrn.onWall (s.x + s.addx, s.y + s.addy)) {
		s.x += s.addx;
		s.y += s.addy;
	}

	if (shipHitAliens ()) return;

	if (!(s.invCount % 2)) s.show ();
	if (s.invCount) --s.invCount;
}

void gameCls::moveAlien (const int i) {
	int difX = s.x - aliens[i].x, difY = s.y - aliens[i].y;
	int choX[4], choY[4];
	unsigned cho = 0;

	aliens[i].show (0);

	if (abs (difX) < abs (difY)) {
		choX[0] = 0;
		choY[0] = difY < 0 ? -1 : 1;
		choY[1] = 0;
		choX[1] = difX < 0 ? -1 : 1;
	} else {
		choX[1] = 0;
		choY[1] = difY < 0 ? -1 : 1;
		choY[0] = 0;
		choX[0] = difX < 0 ? -1 : 1;
	}
	choX[2] = -choX[1];
	choY[2] = -choY[1];
	choX[3] = -choX[0];
	choY[3] = -choY[0];


	while (scrn.DeadEnd (aliens[i].x, aliens[i].y,
				 choX[cho], choY[cho]) && cho < 4)
		cho++;
	if (cho < 4) {
		aliens[i].x += choX[cho];
		aliens[i].y += choY[cho];
	}

	if (alienHitBullet (i)) return;
	if (alienHitShip (i)) return;

	aliens[i].show ();
}

void gameCls::moveBullet (const int i) {
	s.bullets[i].show (0);

	s.bullets[i].x += s.bullets[i].addx;
	s.bullets[i].y += s.bullets[i].addy;

	if (scrn.onWall (s.bullets[i].x, s.bullets[i].y) ||
			bulletHitAlien (i))
		s.removeBullet (i);
	else
		s.bullets[i].show ();
}

void gameCls::loop () {
	for (;;) {
		for (int i = 0; i < s.numOfBullets; i++)
			if (s.bullets[i].goYet ()) moveBullet (i);

		if (s.goYet ()) moveShip ();

		for (i = 0; i < NumOfAliens; i++)
			if (!aliens[i].killed &&
			aliens[i].goYet ())
				moveAlien (i);

		if (allDead ()) NextStage ();

		if (!kbhit ()) continue;

		switch (tolower (getch ())) {
			case 'w' :
			case '8' :
				s.addxN = 0; s.addyN = -1;
				break;
			case 's' :
			case '2' :
				s.addxN = 0; s.addyN = 1;
				break;
			case 'a' :
			case '4' :
				s.addxN = -1; s.addyN = 0;
				break;
			case 'd' :
      case '6' :
				s.addxN = 1; s.addyN = 0;
				break;
			case ' ' :
				s.fire ();
				break;
			case 27 :
				exit (EXIT_SUCCESS);
		}

	}//for
}

int gameCls::shipHitAliens () {
	int result = 0;

	for (unsigned i = 0; i < NumOfAliens; i++)
		if (s.x == aliens[i].x &&
				s.y == aliens[i].y &&
				!aliens[i].killed &&
				!s.invCount) {
			result = aliens[i].killed = 1;
			killedShip ();
		}

	return result;
}

int gameCls::alienHitShip (const unsigned i) {
	if (s.x == aliens[i].x && s.y == aliens[i].y &&
			!s.invCount) {
		killedShip ();
		return aliens[i].killed = 1;
	}

	return 0;
}

void gameCls::killedShip () {
	printf ("\a");
	if (!--s.lives) endGame (0);
	s.invCount = s.MaxInvCount;
	printStatus ();
}

void gameCls::printStatus () {
	gotoxy (1, scrn.scRows + 1);
	printf ("Lives = %u; Score = %u; Stage = %u",
					s.lives, s.score, scrn.stage);
}

int gameCls::bulletHitAlien (const unsigned j) {
	int result = 0;

	for (unsigned i = 0; i < NumOfAliens; i++)
		if (aliens[i].x == s.bullets[j].x &&
				aliens[i].y == s.bullets[j].y &&
				!aliens[i].killed) {
			result = 1;
			aliens[i].killed = 1;
			aliens[i].show (0);
			s.incScore ();
		}

	printStatus ();
	return result;
}

int gameCls::alienHitBullet (const unsigned i) {
	int result = 0;

	for (unsigned j = 0; j < s.numOfBullets; j++)
		if (aliens[i].x == s.bullets[j].x &&
				aliens[i].y == s.bullets[j].y &&
				!aliens[i].killed) {
			result = 1;
			aliens[i].killed = 1;
			s.bullets[j].show (0);
			s.incScore ();
			s.removeBullet (j);
		}

	printStatus ();
	return result;
}

void gameCls::endGame (int i) {
	delay (1000);
	clrscr ();

	if (i)
		puts ("Congradulations!");
	else
		puts ("Game Over");

	sleep (1);
	putchar ('\n');
	puts ("ALIEN FORCE");

	sleep (1);
	putchar ('\n');
	puts ("Game by: Jimmy Reumuth");

	sleep (1);
	putchar ('\n');
	puts ("August 24, 1998");

	exit (EXIT_SUCCESS);
}

int gameCls::allDead () {
	for (unsigned i = 0; i < NumOfAliens; i++)
		if (!aliens[i].killed) return 0;

	return 1;
}

void gameCls::NextStage () {
	scrn.stage++;
	if (scrn.LoadStage ()) endGame (1);

	s.shipInit ();
	scrn.getRndCoords (s.x, s.y);
	s.show ();

	delete [] s.bullets;
	s.bullets = new bulletCls[++s.MaxBullets];

	delete [] aliens;
	aliens = new alienCls[++NumOfAliens];
	for (unsigned i = 0; i < NumOfAliens; i++) {
		aliens[i].alienInit ();
		scrn.getRndCoords (aliens[i].x, aliens[i].y);
		aliens[i].show ();
	}

	printStatus ();
}
