class screenCls {
	protected:
		char **scr;

	public:
		unsigned scCols, scRows;
		unsigned stage;

		screenCls () {
			stage = 1;
			if (LoadStage ()) exit (EXIT_SUCCESS);
		}

		~screenCls () {
			delete[] scr;
		}

		int LoadStage ();

		char *GetStageName ();

		char onWall (int x, int y) {
			if (x < 0 || y < 0 || x >= scCols || y >= scRows)
				return -1;

			return scr[y][x] != ' ';
		}

		void getRndCoords (int &x, int &y);

		int DeadEnd (int x, int y, int addx, int addy);

};

int screenCls::LoadStage () {
	FILE *fp;

	if (NULL == (fp = fopen (GetStageName (), "r")))
		return 1;

		fscanf (fp, "%i", &scRows);
		fscanf (fp, "%i%*c", &scCols);

		if (stage > 1) delete [] scr;
		scr = new char*[scRows];
		clrscr ();
		for (int i = 0; i < scRows; i++) {
			scr[i] = new char[scCols + 2];

			fgets (scr[i], scCols + 2, fp);
			if (ferror (fp)) {
				puts ("Trouble reading file");
				exit (EXIT_FAILURE);
			}

			printf ("%s", scr[i]);
		}

	fclose (fp);
	return 0;
}

char* screenCls::GetStageName () {
	char *s = "stage_?.txt";
	s[6] = stage + '0';
	return s;
}

void screenCls::getRndCoords (int &x, int &y) {
	do {
		x = rand () % scCols;
		y = rand () % scRows;
	} while (onWall (x, y));
}

int screenCls::DeadEnd (int x, int y, int addx, int addy) {
	for (;;) {
		if (onWall (x += addx, y += addy)) return 1;
		if (!onWall (x + addy, y + addx) ||
				!onWall (x - addy, y - addx)) return 0;
	}
}

